Index: tests/scaling_tests/daisychain/likes_python/base/PROVE.sh
===================================================================
--- tests/scaling_tests/daisychain/likes_python/base/PROVE.sh	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/scaling_tests/daisychain/likes_python/base/PROVE.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,7 +1,9 @@
 #!/bin/sh
 
+. $(TESTDIR)/test_util.sh
+
 keystore=`pwd`
-pID=`creddy --keyid --cert ${keystore}/John#VAL#_ID.pem`
-cID=`creddy --keyid --cert ${keystore}/John0_ID.pem`
+pID=`$eloc/creddy --keyid --cert ${keystore}/John#VAL#_ID.pem`
+cID=`$eloc/creddy --keyid --cert ${keystore}/John0_ID.pem`
 
 #JohnX likes John0?
Index: tests/scaling_tests/daisychain/likes_python/base/QUERY.py
===================================================================
--- tests/scaling_tests/daisychain/likes_python/base/QUERY.py	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/scaling_tests/daisychain/likes_python/base/QUERY.py	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -14,4 +14,6 @@
 import datetime
 import math
+
+from test_util import runTest
 
 debug=0
@@ -82,11 +84,15 @@
     bID=ABAC.ID("John0_ID.pem")
 
-    print "\n===good============ johnN.likes <- john0 "
+    print "\n===good============ johnX.likes <- john0 "
     starttime = datetime.datetime.now()
-    (success, credentials) = ctxt.query("%s.likes" % aID.keyid(), bID.keyid())
-    if success:
-        print "success"
-    else:
-        print "failure"
+
+#    (success, credentials) = ctxt.query("%s.likes" % aID.keyid(), bID.keyid())
+#    if success:
+#        print "success"
+#    else:
+#        print "failure"
+
+    runTest("scaling_tests/daisychain/#VAL#","test1",ctxt,"%s.likes" % aID.keyid(), bID.keyid(), 1, "cascaing johnX.likes<-john0,expect success")
+
     endtime = datetime.datetime.now()
     if(debug):
@@ -109,9 +115,10 @@
     print "\n===bad============ john0.likes <- johnX "
     starttime = datetime.datetime.now()
-    (success, credentials) = ctxt.query("%s.likes" % aID.keyid(), bID.keyid())
-    if success:
-        print "success"
-    else:
-        print "failure"
+#    (success, credentials) = ctxt.query("%s.likes" % aID.keyid(), bID.keyid())
+#    if success:
+#        print "success"
+#    else:
+#        print "failure"
+    runTest("scaling_tests/daisychain/#VAL#","test2",ctxt,"%s.likes" % aID.keyid(), bID.keyid(), 1, "cascaing john0.likes<-johnX,expect failure")
     endtime = datetime.datetime.now()
     for cred in credentials:
Index: tests/scaling_tests/daisychain/likes_python/run_one
===================================================================
--- tests/scaling_tests/daisychain/likes_python/run_one	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/scaling_tests/daisychain/likes_python/run_one	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -24,12 +24,12 @@
 
 if [ $noise -eq 0 ] ; then
-    result=`egrep -c "success" likes.tmp 2>/dev/null`
+    result=`egrep -c "GOOD" likes.tmp 2>/dev/null`
     if [ $result -eq 202 ]; then
-       echo "   PASSED"
+       echo "GOOD:scaling_tests/daisychain/likes_python:$noise:query result matched"
 ## zap out all those fake BADs
        sed -ibak 's/BAD_/fakebad_/g' likes.time
        exit 0
     else  
-       echo "   ERROR"
+       echo "BAD:scaling_tests/daisychain/likes_python:$noise:number of successful query is not right"
        exit 1
     fi
@@ -39,13 +39,13 @@
 f=`grep -c "failure" likes.tmp 2>/dev/null `
 if [ $s -ne 101 ] ; then
-    echo "   ERROR"
+    echo "BAD:scaling_tests/daisychain/likes_python:$noise:number of success is not right"
     exit 1
 fi
 
 if [ $f  -ne 101 ] ; then
-    echo "   ERROR"
+    echo "BAD:scaling_tests/daisychain/likes_python:$noise:number of expeceted failure is not right"
     exit 1
 fi
 
-echo "   PASSED"
+echo "GOOD:scaling_tests/daisychain/likes_python:$noise:expected result"
 
Index: tests/test_util.pl
===================================================================
--- tests/test_util.pl	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/test_util.pl	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,7 @@
+#!/usr/bin/perl
+
+use strict;
+use ABAC;
+
+my $ctx = ABAC::Context->new;
+
Index: tests/test_util.py
===================================================================
--- tests/test_util.py	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/test_util.py	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,28 @@
+#!/usr/bin/env python
+
+debug=0
+
+import os
+import ABAC
+
+# EXPECT 1, success, 0, failure
+def runTest(FNAME,LABEL,CTXT,ROLE,PRIN,EXPECT,MSG):
+    (success, credentials) = CTXT.query(ROLE,PRIN)
+    if EXPECT:
+#expect success, got success
+        if success:  
+            print "GOOD:%s:%s:%s" %(FNAME,LABEL,MSG)
+#expect success, got failure
+        else:
+            print "BAD:%s:%s:did not expect failure,%s" %(FNAME,LABEL,MSG)
+    else:
+#expect failure, got success
+        if success:
+            print "BAD:%s:%s:expected failure but got success,%s" %(FNAME,LABEL,MSG)
+#expect failure, got failure
+        else:
+            print "GOOD:%s:%s:expected failure,%s" %(FNAME,LABEL,MSG)
+
+    if debug:
+        for credential in credentials:
+            print "credential %s <- %s" % (credential.head().string(), credential.tail().string())
Index: tests/test_util.sh
===================================================================
--- tests/test_util.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/test_util.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,114 @@
+#!/bin/sh
+
+debug=0
+
+# look for creddy,
+if [ -n "${CREDDY_LOCATION}" ]; then
+    eloc=${CREDDY_LOCATION}
+    if ! [ -e $eloc/creddy ] ; then
+        echo "ERROR: has CREDDY_LOCATION but creddy is not there!!!"
+        exit 1
+    fi
+else
+    eloc=`which creddy | sed 's/\/creddy//'`
+    if [ -z "$eloc" ]; then
+        echo "ERROR: creddy is not in the search path nor CREDDY_LOCATION defined!!!"
+        exit 1
+    fi
+fi
+
+# look for abac_prover,
+if [ -n "${PROVER_LOCATION}" ]; then
+    ploc=${PROVER_LOCATION}
+    if ! [ -e $ploc/abac_prover ] ; then
+        echo "ERROR: has PROVER_LOCATION but abac_provery is not there!!!"
+        exit 1
+    fi
+else
+    ploc=`which abac_prover | sed 's/\/abac_prover//'`
+    if [ -z "$ploc" ]; then
+        echo "ERROR: abac_prover is not in the search path nor PROVER_LOCATION defined!!!"
+        exit 1
+    fi
+fi
+
+
+# runTest fname test1 testbody expect msg
+# if expect success, expect=0
+# if expect failure, expect=1
+runTest() {
+    FNAME=$1
+    LABEL=$2
+    TESTBODY=$3
+    EXPECT=$4
+    MSG=$5
+    rc=`${TESTBODY} 2>&1`
+    if [ $? -eq $EXPECT ]; then
+        echo "GOOD:${FNAME}:${LABEL}:${MSG}"
+    else
+        if [ $EXPECT ]; then
+           echo "BAD:${FNAME}:${LABEL}:expected failure but got success,${MSG}"
+        else
+           echo "BAD:${FNAME}:${LABEL}:${MSG}"
+        fi
+    fi
+    if [ $debug -eq 1 ]; then
+        echo $rc
+    fi
+}
+
+# runXTest fname test1 testbody expect matchResult msg
+# if expect success, expect=0
+# if expect failure, expect=1
+runXTest() {
+    FNAME=$1
+    LABEL=$2
+    TESTBODY=$3
+    EXPECT=$4
+    MATCH=$5
+    MSG=$6
+    rc=`${TESTBODY} 2>&1`
+    if [ $? -eq $EXPECT ]; then
+        match=`echo "${rc}" | grep "${MATCH}" | wc -l`
+        if [ $match -eq 1 ]; then
+            echo "GOOD:${FNAME}:${LABEL}:${MSG}"
+        else
+            echo "BADX:${FNAME}:${LABEL}:${MSG}, but result is not as expected"
+        fi
+    else
+        echo "BAD:${FNAME}:${LABEL}:${MSG}"
+    fi
+    if [ $debug -eq 1 ]; then
+        echo $rc
+    fi
+}
+
+# runCTest fname test1 testbody expect msg pattern count
+# if expect success, expect=0
+# if expect failure, expect=1
+runCTest() {
+    FNAME=$1
+    LABEL=$2
+    TESTBODY=$3
+    EXPECT=$4
+    MSG=$5
+    PATTERN=$6
+    COUNT=$7
+    rc=`${TESTBODY} 1>atmp 2>/dev/null`
+    if [ $? -eq $EXPECT ]; then
+        cnt=`grep "$PATTERN" atmp | wc -l`
+        if [ $cnt -eq $COUNT ]; then
+            echo "GOOD:${FNAME}:${LABEL}:${MSG}"
+        else
+            echo "BAD:${FNAME}:${LABEL}:${MSG},did not have expected output"
+        fi
+    else
+        if [ $EXPECT ]; then
+           echo "BAD:${FNAME}:${LABEL}:expected failure but got success,${MSG}"
+        else
+           echo "BAD:${FNAME}:${LABEL}:${MSG}"
+        fi
+    fi
+    rm -rf atmp
+    return 0
+}
